Index: GTP/trunk/App/Games/Jungle_Rumble/src/WuermerDX9_2003.vcproj
===================================================================
--- GTP/trunk/App/Games/Jungle_Rumble/src/WuermerDX9_2003.vcproj	(revision 1378)
+++ GTP/trunk/App/Games/Jungle_Rumble/src/WuermerDX9_2003.vcproj	(revision 1380)
@@ -83,5 +83,5 @@
 				InlineFunctionExpansion="1"
 				OmitFramePointers="TRUE"
-				AdditionalIncludeDirectories=".\physic\Cooking\include;.\physic\PhysXLoader\include;.\physic\Physics\include;.\physic\Foundation\include;Common"
+				AdditionalIncludeDirectories="..\..\..\..\..\..\NonGTP\Boost;.\physic\Cooking\include;.\physic\PhysXLoader\include;.\physic\Physics\include;.\physic\Foundation\include;Common"
 				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS"
 				StringPooling="TRUE"
@@ -188,4 +188,66 @@
 				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
 		</Configuration>
+		<Configuration
+			Name="Release_GTP|Win32"
+			OutputDirectory="$(ConfigurationName)"
+			IntermediateDirectory="$(ConfigurationName)"
+			ConfigurationType="1"
+			CharacterSet="1">
+			<Tool
+				Name="VCCLCompilerTool"
+				Optimization="3"
+				GlobalOptimizations="TRUE"
+				FavorSizeOrSpeed="1"
+				OptimizeForProcessor="3"
+				AdditionalIncludeDirectories="..\..\..\..\..\..\NonGTP\Boost;.\physic\Cooking\include;.\physic\PhysXLoader\include;.\physic\Physics\include;.\physic\Foundation\include;Common"
+				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS"
+				MinimalRebuild="TRUE"
+				BasicRuntimeChecks="0"
+				RuntimeLibrary="0"
+				BufferSecurityCheck="FALSE"
+				EnableFunctionLevelLinking="TRUE"
+				EnableEnhancedInstructionSet="1"
+				UsePrecompiledHeader="2"
+				PrecompiledHeaderThrough="dxstdafx.h"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="3"
+				DisableSpecificWarnings="4995; 4512"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLinkerTool"
+				AdditionalOptions="/IGNORE:4089 /MAPINFO:LINES"
+				AdditionalDependencies="dxerr9.lib dxguid.lib d3dx9d.lib d3d9.lib winmm.lib comctl32.lib dsound.lib dinput8.lib "
+				OutputFile="..\bin\JungleRumble.exe"
+				LinkIncremental="2"
+				GenerateDebugInformation="TRUE"
+				ProgramDatabaseFile="$(OutDir)/WuermerDX9.pdb"
+				GenerateMapFile="TRUE"
+				MapExports="TRUE"
+				MapLines="TRUE"
+				SubSystem="2"
+				TargetMachine="1"/>
+			<Tool
+				Name="VCMIDLTool"/>
+			<Tool
+				Name="VCPostBuildEventTool"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool
+				Name="VCWebDeploymentTool"/>
+			<Tool
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
 	</Configurations>
 	<References>
@@ -248,4 +310,10 @@
 				<FileConfiguration
 					Name="Profile|Win32">
+					<Tool
+						Name="VCCLCompilerTool"
+						UsePrecompiledHeader="1"/>
+				</FileConfiguration>
+				<FileConfiguration
+					Name="Release_GTP|Win32">
 					<Tool
 						Name="VCCLCompilerTool"
Index: GTP/trunk/App/Games/Jungle_Rumble/src/WuermerDX9_2003.sln
===================================================================
--- GTP/trunk/App/Games/Jungle_Rumble/src/WuermerDX9_2003.sln	(revision 1378)
+++ GTP/trunk/App/Games/Jungle_Rumble/src/WuermerDX9_2003.sln	(revision 1380)
@@ -9,4 +9,5 @@
 		Profile = Profile
 		Release = Release
+		Release_GTP = Release_GTP
 	EndGlobalSection
 	GlobalSection(ProjectConfiguration) = postSolution
@@ -17,4 +18,6 @@
 		{9C04CC2D-C188-4443-A185-CB0BCA6ED98D}.Release.ActiveCfg = Release|Win32
 		{9C04CC2D-C188-4443-A185-CB0BCA6ED98D}.Release.Build.0 = Release|Win32
+		{9C04CC2D-C188-4443-A185-CB0BCA6ED98D}.Release_GTP.ActiveCfg = Release_GTP|Win32
+		{9C04CC2D-C188-4443-A185-CB0BCA6ED98D}.Release_GTP.Build.0 = Release_GTP|Win32
 	EndGlobalSection
 	GlobalSection(ExtensibilityGlobals) = postSolution
Index: GTP/trunk/App/Games/Jungle_Rumble/src/common/dxut.cpp
===================================================================
--- GTP/trunk/App/Games/Jungle_Rumble/src/common/dxut.cpp	(revision 1378)
+++ GTP/trunk/App/Games/Jungle_Rumble/src/common/dxut.cpp	(revision 1380)
@@ -4388,5 +4388,6 @@
                     }
 
-                    case VK_PAUSE: 
+                    case VK_F5: // MG
+										case VK_PAUSE: 
                     {
                         bool bTimePaused = DXUTIsTimePaused();