Index: GTP/trunk/App/Games/Jungle_Rumble/src/GameManager.cpp
===================================================================
--- GTP/trunk/App/Games/Jungle_Rumble/src/GameManager.cpp	(revision 1382)
+++ GTP/trunk/App/Games/Jungle_Rumble/src/GameManager.cpp	(revision 1383)
@@ -74,5 +74,21 @@
 				case VK_F1:
 					if(activeScene == &this->gs) {
-						this->gs.getHUD()->message("HELP:\n drive: w-a-s-d\n shoot: left mouse\n F2: show FPS\n F3: PhysX Debugger\n F4: Music On/Off\n F9: Depth Imposters On/Off\n F10: Raytracer On/Off\n F11 Opponent Fire On/Off\n Pause: Pause Game\n 1 Standard weapon\n 2 Bombs - explode late, but do cause lots of damage!\n 3 Alien weapon - just shoot!\n 4 Firethrower - Toast your opponent\n 5 Icethrower - Slow down your opponent", 2, 0.01f, true);
+						#if(0)
+							this->gs.getHUD()->message("HELP:\n drive: w-a-s-d\n shoot: left mouse\n F2: show FPS\n F3: PhysX Debugger\n F4: Music On/Off\n F9: Depth Imposters On/Off\n F10: Raytracer On/Off\n F11 Opponent Fire On/Off\n Pause: Pause Game\n 1 Standard weapon\n 2 Bombs - explode late, but do cause lots of damage!\n 3 Alien weapon - just shoot!\n 4 Firethrower - Toast your opponent\n 5 Icethrower - Slow down your opponent", 2, 0.01f, true);
+						#else // MG
+							std::string s("");
+							s += "HELP:\n drive: w-a-s-d\n shoot: left mouse\n F2: show FPS\n F3: PhysX Debugger\n F4: Music On/Off";
+							
+							s += "\n F9: Depth Imposters On/Off ";
+							if(this->gs.useDepthImposter) { s+= "[ON]"; } else { s+= "[OFF]"; }
+							
+							s += "\n F10: Raytracer On/Off ";
+							if(this->gs.useRaytracer) { s+= "[ON]"; } else { s+= "[OFF]"; }
+							
+							s += "\n F11 Opponent Fire On/Off\n Pause: Pause Game\n 1 Standard weapon\n 2 Bombs - explode late, but do cause lots of damage!\n 3 Alien weapon - just shoot!\n 4 Firethrower - Toast your opponent\n 5 Icethrower - Slow down your opponent";
+							s += "HELP:\n drive: w-a-s-d\n shoot: left mouse\n F2: show FPS\n F3: PhysX Debugger\n F4: Music On/Off\n F9: Depth Imposters On/Off\n F10: Raytracer On/Off\n F11 Opponent Fire On/Off\n Pause: Pause Game\n 1 Standard weapon\n 2 Bombs - explode late, but do cause lots of damage!\n 3 Alien weapon - just shoot!\n 4 Firethrower - Toast your opponent\n 5 Icethrower - Slow down your opponent";
+							this->gs.getHUD()->message(s, 2, 0.01f, true);
+							//this->gs.useRaytracer
+						#endif
 					}
 					//this->gs.hasWon();
Index: GTP/trunk/App/Games/Jungle_Rumble/src/RaytraceRenderer.h
===================================================================
--- GTP/trunk/App/Games/Jungle_Rumble/src/RaytraceRenderer.h	(revision 1378)
+++ GTP/trunk/App/Games/Jungle_Rumble/src/RaytraceRenderer.h	(revision 1383)
@@ -51,5 +51,4 @@
 	LPDIRECT3DSURFACE9 pCubeMapDistSurf;
 	
-#define CUBEMAP_SIZE		512				// Size of CubeMaps
 
 enum {
Index: GTP/trunk/App/Games/Jungle_Rumble/src/GameSceneLoader.cpp
===================================================================
--- GTP/trunk/App/Games/Jungle_Rumble/src/GameSceneLoader.cpp	(revision 1378)
+++ GTP/trunk/App/Games/Jungle_Rumble/src/GameSceneLoader.cpp	(revision 1383)
@@ -1102,5 +1102,10 @@
 	float fresnel = 0;
 	float refraction = 0;
-	int nbIteration = 10;
+	
+	#if(1)
+		int nbIteration = 10;
+	#else
+		int nbIteration = 3; // MG
+	#endif
 
 	for (MSXML::IXMLDOMNodePtr pChild = rendererNode->firstChild;NULL != pChild;pChild = pChild->nextSibling) {
Index: GTP/trunk/App/Games/Jungle_Rumble/src/RaytraceRenderer.cpp
===================================================================
--- GTP/trunk/App/Games/Jungle_Rumble/src/RaytraceRenderer.cpp	(revision 1378)
+++ GTP/trunk/App/Games/Jungle_Rumble/src/RaytraceRenderer.cpp	(revision 1383)
@@ -6,4 +6,14 @@
 #include "NodeFilter.h"
 #include <ctime>
+
+
+#if(0)
+	#define CUBEMAP_SIZE		512				// Size of CubeMaps (MG: 512 works on both current NVidia and ATI driver)
+#elif(0)
+	#define CUBEMAP_SIZE		1024				// Size of CubeMaps (MG)
+#elif(1)
+	const int CUBEMAP_SIZE = 1024;
+#endif
+
 
 RaytraceRenderer::RaytraceRenderer(void) : Renderer()