Index: /GTP/trunk/App/Games/Jungle_Rumble/src/WuermerDX9.rc
===================================================================
--- /GTP/trunk/App/Games/Jungle_Rumble/src/WuermerDX9.rc	(revision 1378)
+++ /GTP/trunk/App/Games/Jungle_Rumble/src/WuermerDX9.rc	(revision 1386)
@@ -9,5 +9,5 @@
 //
 #define IDC_STATIC -1
-#include <WinResRc.h>
+#include <winresrc.h>
 
 
Index: /GTP/trunk/App/Games/Jungle_Rumble/src/WuermerDX9_2003.vcproj
===================================================================
--- /GTP/trunk/App/Games/Jungle_Rumble/src/WuermerDX9_2003.vcproj	(revision 1380)
+++ /GTP/trunk/App/Games/Jungle_Rumble/src/WuermerDX9_2003.vcproj	(revision 1386)
@@ -212,5 +212,5 @@
 				WarningLevel="3"
 				Detect64BitPortabilityProblems="TRUE"
-				DebugInformationFormat="3"
+				DebugInformationFormat="0"
 				DisableSpecificWarnings="4995; 4512"/>
 			<Tool
@@ -221,10 +221,10 @@
 				AdditionalDependencies="dxerr9.lib dxguid.lib d3dx9d.lib d3d9.lib winmm.lib comctl32.lib dsound.lib dinput8.lib "
 				OutputFile="..\bin\JungleRumble.exe"
-				LinkIncremental="2"
-				GenerateDebugInformation="TRUE"
-				ProgramDatabaseFile="$(OutDir)/WuermerDX9.pdb"
-				GenerateMapFile="TRUE"
-				MapExports="TRUE"
-				MapLines="TRUE"
+				LinkIncremental="1"
+				GenerateDebugInformation="FALSE"
+				ProgramDatabaseFile=""
+				GenerateMapFile="FALSE"
+				MapExports="FALSE"
+				MapLines="FALSE"
 				SubSystem="2"
 				TargetMachine="1"/>
Index: /GTP/trunk/App/Games/Jungle_Rumble/bin/config.xml
===================================================================
--- /GTP/trunk/App/Games/Jungle_Rumble/bin/config.xml	(revision 1384)
+++ /GTP/trunk/App/Games/Jungle_Rumble/bin/config.xml	(revision 1386)
@@ -6,8 +6,8 @@
 	<cubemapsize>512</cubemapsize> <!-- 512, 1024, 2048, ... - current ATI cards have problems with size above 512 -->
 	<physxdebug>0</physxdebug>   <!-- 1 = TRUE, 0 = FALSE -->
-	<challenge><name>Alien Planet</name><location>./media/challenges/moon.xml</location><loadingScreen>./media/textures/moonLoading.jpg</loadingScreen></challenge>
 	<challenge><name>Volcano</name><location>./media/challenges/volcano.xml</location><loadingScreen>./media/textures/vulkanLoading2.jpg</loadingScreen></challenge>	
 	<challenge><name>Surprise!</name><location>./media/challenges/challenge3.xml</location><loadingScreen>./media/textures/surpiseLoading.jpg</loadingScreen></challenge>
-	<challenge><name>Helix Hazard</name><location>./media/challenges/noweapons.xml</location><loadingScreen>./media/textures/spiralsLoading.jpg</loadingScreen></challenge>
 	<challenge><name>Raining...</name><location>./media/challenges/challenge0.xml</location><loadingScreen>./media/textures/rainingLoading.jpg</loadingScreen></challenge>
+	<challenge><name>(Helix Hazard)</name><location>./media/challenges/noweapons.xml</location><loadingScreen>./media/textures/spiralsLoading.jpg</loadingScreen></challenge>
+	<challenge><name>(Alien Planet)</name><location>./media/challenges/moon.xml</location><loadingScreen>./media/textures/moonLoading.jpg</loadingScreen></challenge>
 </config>
Index: /GTP/trunk/App/Games/Jungle_Rumble/bin/readme.txt
===================================================================
--- /GTP/trunk/App/Games/Jungle_Rumble/bin/readme.txt	(revision 1378)
+++ /GTP/trunk/App/Games/Jungle_Rumble/bin/readme.txt	(revision 1386)
@@ -1,11 +1,55 @@
+The European Union GameTools Project (www.gametools.org) presents:
 
 Jungle Rumble
 =============
 
-Choose a level and shoot your opponents to blast them skyhigh.
-Have fun!! :-)
+"Keep your wheels on the ground - and blast your opponents sky high" ;-)
 
-Keys:
-=====
+
+About the Game
+==============
+JungleRumble is GameTools demogame that was created by a small team (2 programmers and 1 artist) 
+of talented students at Vienna University of Technology, to showcase GameTools 
+Depth Imposters and Raytrace Effects.
+
+Depth Imposter solve the problem of conventional flat, semitransparent 
+decals intersecting with opaque scene geometry, which normally shatters their volumetric illusion; 
+
+Raytrace Effects employ actual raytracing on the GPU to give much improved quality for reflection 
+and refraction effects apllied to arbitrarily shaped geometry, especially if the 
+reflected/refracted objects are near the reflector/refractor. 
+
+Raytrace Effects are used for several (see "Raining..." level) - in some levels ("Surprise!") moving - objects. 
+Depth Imposter are used for explosions, lava-fire (see "Volcano" level) and for the 
+partcicle effects of the Flame- and Icethrower (press "4" and "5" to activate these), 
+combined with a heat blur.
+
+Jungle Rumble was started in the early phase of the GameTools Project, 
+and therefore uses its own Direct3D 9 engine (and not OGRE or Shark3D).
+
+The game starts in 800x600 window mode, using 512x512 textures for the Raytrace Effects cubemap. 
+You can easily change these settings in the "config.xml" file, residing in the same directory as this file.
+
+During the game, you can toggle Depth Imposters with conventional decal particle rendering with F9; 
+F10 toggles between Raytrace Effects reflection & refraction and conventional environment maps.
+
+Pressing F1 displays a help screen, where you can also see 
+whether Depth Imposters and Raytrace Effects are currently [ON] or [OFF], respectively.
+
+
+About the GameTools Project
+===========================
+The European Union GameTools Project is funded by the EU and produces 3D libaries 
+based on leading edge computer graphics research. 
+It makes these libraries available to European developers (or companies developing software within the EU)
+for free (including support) !
+All the companies have to do is joing the GTP Special Interest Group.
+To learn more about the GameTools Project and how to join, go to our webpage at http://www.gametools.org, 
+or contact the GTP Community Manager, Markus Giegl, at cm@gametools.org.
+
+
+Keys
+====
+(Press F1 during the game, to get the same information)
 
 w-a-s-d		Navigate your vehicle
@@ -23,3 +67,15 @@
 F9		Depthimposters on/off
 F10		Raytracer on/off
-F11		Enable/Disable fire of the opponents (Not for cheating! ;-)
+F11		Enable/Disable fire of the opponents (For looking at the GameTools effects undisturbed - no cheating! ;-)
+
+
+Enjoy,
+Markus Giegl
+
+Community Manager
+GameTools Project
+www.gametools.org
+
+
+
+