Index: GTP/trunk/App/Games/Jungle_Rumble/src/GameManager.cpp
===================================================================
--- GTP/trunk/App/Games/Jungle_Rumble/src/GameManager.cpp	(revision 1383)
+++ GTP/trunk/App/Games/Jungle_Rumble/src/GameManager.cpp	(revision 1388)
@@ -13,4 +13,7 @@
 
 
+bool GLOBAL_display_help_screenQ = false;
+
+
 GameManager::GameManager(void)
 {
@@ -76,5 +79,5 @@
 						#if(0)
 							this->gs.getHUD()->message("HELP:\n drive: w-a-s-d\n shoot: left mouse\n F2: show FPS\n F3: PhysX Debugger\n F4: Music On/Off\n F9: Depth Imposters On/Off\n F10: Raytracer On/Off\n F11 Opponent Fire On/Off\n Pause: Pause Game\n 1 Standard weapon\n 2 Bombs - explode late, but do cause lots of damage!\n 3 Alien weapon - just shoot!\n 4 Firethrower - Toast your opponent\n 5 Icethrower - Slow down your opponent", 2, 0.01f, true);
-						#else // MG
+						#elif(1) // MG
 							std::string s("");
 							s += "HELP:\n drive: w-a-s-d\n shoot: left mouse\n F2: show FPS\n F3: PhysX Debugger\n F4: Music On/Off";
@@ -90,4 +93,6 @@
 							this->gs.getHUD()->message(s, 2, 0.01f, true);
 							//this->gs.useRaytracer
+						#elif(0) // MG
+							GLOBAL_display_help_screenQ = !GLOBAL_display_help_screenQ;
 						#endif
 					}
Index: GTP/trunk/App/Games/Jungle_Rumble/src/WuermerDX9.rc
===================================================================
--- GTP/trunk/App/Games/Jungle_Rumble/src/WuermerDX9.rc	(revision 1386)
+++ GTP/trunk/App/Games/Jungle_Rumble/src/WuermerDX9.rc	(revision 1388)
@@ -32,13 +32,4 @@
 1                       RT_MANIFEST             "WuermerDX9.manifest"
 
-/////////////////////////////////////////////////////////////////////////////
-//
-// Icon
-//
-
-// Icon with lowest ID value placed first to ensure application icon
-// remains consistent on all systems.
-IDI_MAIN_ICON           ICON                    "Common\\directx.ico"
-
 #ifdef APSTUDIO_INVOKED
 /////////////////////////////////////////////////////////////////////////////
@@ -73,4 +64,25 @@
 
 
+/////////////////////////////////////////////////////////////////////////////
+// German (Austria) resources
+
+#if !defined(AFX_RESOURCE_DLL) || defined(AFX_TARG_DEA)
+#ifdef _WIN32
+LANGUAGE LANG_GERMAN, SUBLANG_GERMAN_AUSTRIAN
+#pragma code_page(1252)
+#endif //_WIN32
+
+/////////////////////////////////////////////////////////////////////////////
+//
+// Icon
+//
+
+// Icon with lowest ID value placed first to ensure application icon
+// remains consistent on all systems.
+IDI_ICON3               ICON                    "common\\gtp_jungle_rumble1.ico"
+#endif    // German (Austria) resources
+/////////////////////////////////////////////////////////////////////////////
+
+
 
 #ifndef APSTUDIO_INVOKED
Index: GTP/trunk/App/Games/Jungle_Rumble/src/WuermerDX9_2003.vcproj
===================================================================
--- GTP/trunk/App/Games/Jungle_Rumble/src/WuermerDX9_2003.vcproj	(revision 1386)
+++ GTP/trunk/App/Games/Jungle_Rumble/src/WuermerDX9_2003.vcproj	(revision 1388)
@@ -262,4 +262,19 @@
 			<File
 				RelativePath=".\fmod.dll">
+			</File>
+			<File
+				RelativePath=".\common\gtp32x32.ico">
+			</File>
+			<File
+				RelativePath=".\common\gtp32x32_2.ico">
+			</File>
+			<File
+				RelativePath=".\common\gtp_jungle_rumble1.ico">
+			</File>
+			<File
+				RelativePath=".\common\ice blue cube 32x32 2.ico">
+			</File>
+			<File
+				RelativePath=".\common\icon2.ico">
 			</File>
 			<File
Index: GTP/trunk/App/Games/Jungle_Rumble/src/resource.h
===================================================================
--- GTP/trunk/App/Games/Jungle_Rumble/src/resource.h	(revision 1378)
+++ GTP/trunk/App/Games/Jungle_Rumble/src/resource.h	(revision 1388)
@@ -3,5 +3,5 @@
 // Used by WuermerDX9.rc
 //
-#define IDI_MAIN_ICON                   101
+#define IDI_ICON3                       116
 
 // Next default values for new objects
@@ -9,5 +9,5 @@
 #ifdef APSTUDIO_INVOKED
 #ifndef APSTUDIO_READONLY_SYMBOLS
-#define _APS_NEXT_RESOURCE_VALUE        113
+#define _APS_NEXT_RESOURCE_VALUE        117
 #define _APS_NEXT_COMMAND_VALUE         40029
 #define _APS_NEXT_CONTROL_VALUE         1000