Index: /GTP/trunk/App/Games/Jungle_Rumble/src/GameManager.cpp
===================================================================
--- /GTP/trunk/App/Games/Jungle_Rumble/src/GameManager.cpp	(revision 1388)
+++ /GTP/trunk/App/Games/Jungle_Rumble/src/GameManager.cpp	(revision 1389)
@@ -66,4 +66,21 @@
 }
 
+
+std::wstring GameManager::HelpScreenString_Get()
+{
+	std::wstring s;
+	s += L"HELP:\n drive: w-a-s-d\n shoot: left mouse\n F2: show FPS\n F3: PhysX Debugger\n F4: Music On/Off";
+	
+	s += L"\n F9: Depth Imposters On/Off ";
+	if(this->gs.useDepthImposter) { s+= L"[ON]"; } else { s+= L"[OFF]"; }
+	
+	s += L"\n F10: Raytracer On/Off ";
+	if(this->gs.useRaytracer) { s+= L"[ON]"; } else { s+= L"[OFF]"; }
+	
+	s += L"\n F11 Opponent Fire On/Off\n Pause: Pause Game\n 1 Standard weapon\n 2 Bombs - explode late, but do cause lots of damage!\n 3 Alien weapon - just shoot!\n 4 Firethrower - Toast your opponent\n 5 Icethrower - Slow down your opponent";
+	return s;
+}
+
+
 void GameManager::keyPressed(UINT nChar, bool bKeyDown, bool bAltDown, void* pUserContext)
 {
@@ -79,5 +96,5 @@
 						#if(0)
 							this->gs.getHUD()->message("HELP:\n drive: w-a-s-d\n shoot: left mouse\n F2: show FPS\n F3: PhysX Debugger\n F4: Music On/Off\n F9: Depth Imposters On/Off\n F10: Raytracer On/Off\n F11 Opponent Fire On/Off\n Pause: Pause Game\n 1 Standard weapon\n 2 Bombs - explode late, but do cause lots of damage!\n 3 Alien weapon - just shoot!\n 4 Firethrower - Toast your opponent\n 5 Icethrower - Slow down your opponent", 2, 0.01f, true);
-						#elif(1) // MG
+						#elif(0) // MG
 							std::string s("");
 							s += "HELP:\n drive: w-a-s-d\n shoot: left mouse\n F2: show FPS\n F3: PhysX Debugger\n F4: Music On/Off";
@@ -90,8 +107,8 @@
 							
 							s += "\n F11 Opponent Fire On/Off\n Pause: Pause Game\n 1 Standard weapon\n 2 Bombs - explode late, but do cause lots of damage!\n 3 Alien weapon - just shoot!\n 4 Firethrower - Toast your opponent\n 5 Icethrower - Slow down your opponent";
-							s += "HELP:\n drive: w-a-s-d\n shoot: left mouse\n F2: show FPS\n F3: PhysX Debugger\n F4: Music On/Off\n F9: Depth Imposters On/Off\n F10: Raytracer On/Off\n F11 Opponent Fire On/Off\n Pause: Pause Game\n 1 Standard weapon\n 2 Bombs - explode late, but do cause lots of damage!\n 3 Alien weapon - just shoot!\n 4 Firethrower - Toast your opponent\n 5 Icethrower - Slow down your opponent";
+							//s += "HELP:\n drive: w-a-s-d\n shoot: left mouse\n F2: show FPS\n F3: PhysX Debugger\n F4: Music On/Off\n F9: Depth Imposters On/Off\n F10: Raytracer On/Off\n F11 Opponent Fire On/Off\n Pause: Pause Game\n 1 Standard weapon\n 2 Bombs - explode late, but do cause lots of damage!\n 3 Alien weapon - just shoot!\n 4 Firethrower - Toast your opponent\n 5 Icethrower - Slow down your opponent";
 							this->gs.getHUD()->message(s, 2, 0.01f, true);
 							//this->gs.useRaytracer
-						#elif(0) // MG
+						#elif(1) // MG
 							GLOBAL_display_help_screenQ = !GLOBAL_display_help_screenQ;
 						#endif
Index: /GTP/trunk/App/Games/Jungle_Rumble/src/WuermerDX9_2003.vcproj
===================================================================
--- /GTP/trunk/App/Games/Jungle_Rumble/src/WuermerDX9_2003.vcproj	(revision 1388)
+++ /GTP/trunk/App/Games/Jungle_Rumble/src/WuermerDX9_2003.vcproj	(revision 1389)
@@ -202,5 +202,5 @@
 				AdditionalIncludeDirectories="..\..\..\..\..\..\NonGTP\Boost;.\physic\Cooking\include;.\physic\PhysXLoader\include;.\physic\Physics\include;.\physic\Foundation\include;Common"
 				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS"
-				MinimalRebuild="TRUE"
+				MinimalRebuild="FALSE"
 				BasicRuntimeChecks="0"
 				RuntimeLibrary="0"
Index: /GTP/trunk/App/Games/Jungle_Rumble/src/GameManager.h
===================================================================
--- /GTP/trunk/App/Games/Jungle_Rumble/src/GameManager.h	(revision 1378)
+++ /GTP/trunk/App/Games/Jungle_Rumble/src/GameManager.h	(revision 1389)
@@ -38,5 +38,7 @@
 	void updateGame(float fElapsedTime);
 	void initGame();
-	
+
+	std::wstring HelpScreenString_Get();
+  	
 	ID3DXEffect* getEffect(UINT id);
 	ID3DXEffect* loadEffect(UINT id, LPCWSTR filename);
Index: /GTP/trunk/App/Games/Jungle_Rumble/src/HUDRenderer.cpp
===================================================================
--- /GTP/trunk/App/Games/Jungle_Rumble/src/HUDRenderer.cpp	(revision 1378)
+++ /GTP/trunk/App/Games/Jungle_Rumble/src/HUDRenderer.cpp	(revision 1389)
@@ -4,4 +4,7 @@
 #include "UserPlayer.h"
 #include "HUD.h"
+
+extern bool GLOBAL_display_help_screenQ;
+
 
 HUDRenderer::HUDRenderer(void) : Renderer()
@@ -211,12 +214,38 @@
 
 			//message output:
-			if (hud->messagetimer < hud->messagethreshold) {
-				hud->messagetimer += hud->messagedt;
-				if(!hud->bHelp) {
-                    myFont->DrawText(sprite, hud->messagestring.c_str(), -1, &textRectangle, DT_CENTER | DT_WORDBREAK, fontColor);
-				} else {
-					myFont->DrawText(sprite, hud->messagestring.c_str(), -1, &helpRectangle, DT_LEFT | DT_WORDBREAK, fontColor);
-				}
-			}
+			#if(0)
+				// display message for messagethreshold period of time
+				if (hud->messagetimer < hud->messagethreshold) {
+					hud->messagetimer += hud->messagedt;
+					if(!hud->bHelp) {
+											myFont->DrawText(sprite, hud->messagestring.c_str(), -1, &textRectangle, DT_CENTER | DT_WORDBREAK, fontColor);
+					} 
+					else {
+						myFont->DrawText(sprite, hud->messagestring.c_str(), -1, &helpRectangle, DT_LEFT | DT_WORDBREAK, fontColor);
+					}
+				}
+			#elif(1) // MG
+				// F1 toggles help screen display
+				if (hud->messagetimer < hud->messagethreshold) {
+					hud->messagetimer += hud->messagedt;
+				}
+
+				if(GLOBAL_display_help_screenQ) {
+						//std::wstring str_helpscreen(this->myScene->manager->HelpScreenString_Get());
+						//this->myScene->manager->
+          	//myFont->DrawText(sprite, hud->messagestring.c_str(), -1, &helpRectangle, DT_LEFT | DT_WORDBREAK, fontColor);
+						//myFont->DrawText(sprite, str_helpscreen.c_str(), -1, &helpRectangle, DT_LEFT | DT_WORDBREAK, fontColor);
+						myFont->DrawText(sprite, this->myScene->manager->HelpScreenString_Get().c_str(), -1, &helpRectangle, DT_LEFT | DT_WORDBREAK, fontColor);
+				}
+				else {
+					// No help screen active => display message (if active)
+					if (hud->messagetimer < hud->messagethreshold) {
+						//hud->messagetimer += hud->messagedt;
+						//if(!hud->bHelp) {
+						myFont->DrawText(sprite, hud->messagestring.c_str(), -1, &textRectangle, DT_CENTER | DT_WORDBREAK, fontColor);
+						//} 
+					}
+				}
+			#endif
 
 			//you win output: