Index: /GTP/trunk/App/Games/Jungle_Rumble/src/GameManager.cpp
===================================================================
--- /GTP/trunk/App/Games/Jungle_Rumble/src/GameManager.cpp	(revision 1399)
+++ /GTP/trunk/App/Games/Jungle_Rumble/src/GameManager.cpp	(revision 1403)
@@ -14,4 +14,5 @@
 
 bool GLOBAL_display_help_screenQ = false;
+bool GLOBAL_player_freezeQ = false;
 
 
@@ -148,4 +149,5 @@
 				case VK_F7:
 					//this->gs.getHUD()->displayLose(3, 0.01f);
+					GLOBAL_player_freezeQ = !GLOBAL_player_freezeQ;
 					break;
 				case VK_F8:
Index: /GTP/trunk/App/Games/Jungle_Rumble/src/Player.cpp
===================================================================
--- /GTP/trunk/App/Games/Jungle_Rumble/src/Player.cpp	(revision 1401)
+++ /GTP/trunk/App/Games/Jungle_Rumble/src/Player.cpp	(revision 1403)
@@ -390,5 +390,7 @@
 }
 
+
 void Player::update(float dt) {
+
 	if(this->sleepCounter++<10) {
 		if(this->sleepCounter==2) {
@@ -478,4 +480,5 @@
 	}
 }
+
 
 void Player::updateDrivingPlayer(float dt) {
Index: /GTP/trunk/App/Games/Jungle_Rumble/src/GameScene.h
===================================================================
--- /GTP/trunk/App/Games/Jungle_Rumble/src/GameScene.h	(revision 1382)
+++ /GTP/trunk/App/Games/Jungle_Rumble/src/GameScene.h	(revision 1403)
@@ -176,4 +176,4 @@
 	float resultShowingTimer;
 
-	
+	bool ignoreKeys;
 };
Index: /GTP/trunk/App/Games/Jungle_Rumble/src/UserPlayer.h
===================================================================
--- /GTP/trunk/App/Games/Jungle_Rumble/src/UserPlayer.h	(revision 1378)
+++ /GTP/trunk/App/Games/Jungle_Rumble/src/UserPlayer.h	(revision 1403)
@@ -17,6 +17,7 @@
 	/*void initWin();
 	void initLose();
+	*/
+	virtual void update(float dt);
 
-	virtual void update(float dt);*/
 protected:
 	float finalTimer;
Index: /GTP/trunk/App/Games/Jungle_Rumble/src/GameScene.cpp
===================================================================
--- /GTP/trunk/App/Games/Jungle_Rumble/src/GameScene.cpp	(revision 1401)
+++ /GTP/trunk/App/Games/Jungle_Rumble/src/GameScene.cpp	(revision 1403)
@@ -23,4 +23,6 @@
 #define M_PI 3.1415
 
+extern bool GLOBAL_player_freezeQ;
+
 GameScene::GameScene(void) : Scene()
 {
@@ -47,4 +49,6 @@
 	this->currentlypaused = false;
 	this->preparepaused = false;
+
+	this->ignoreKeys = false;
 }
 
@@ -121,4 +125,5 @@
 
 void GameScene::initScene(GameManager &_manager) {
+	this->ignoreKeys = false;
 	this->resultVisible = false;
 	this->won = false;
@@ -757,8 +762,10 @@
 
 	//Update Player instructions
-	if(this->keyDown['W']) player->accelerate();
-	if(this->keyDown['S']) player->stop();
-	if(this->keyDown['A']) player->toLeft();
-	if(this->keyDown['D']) player->toRight();
+	if(!ignoreKeys) {
+		if(this->keyDown['W']) player->accelerate();
+		if(this->keyDown['S']) player->stop();
+		if(this->keyDown['A']) player->toLeft();
+		if(this->keyDown['D']) player->toRight();
+	}
 
 	//Set active Weapons
@@ -983,4 +990,9 @@
 			this->recalcTransformations = false;
 		}
+		if(this->won && this->resultShowingTimer<=5.75f) {
+			//this->player->resetValues();
+			GLOBAL_player_freezeQ = true;
+			this->ignoreKeys = true;
+		}
 		if(this->resultShowingTimer<=0) {
 			this->manager->switchToMenueScene();
Index: /GTP/trunk/App/Games/Jungle_Rumble/src/UserPlayer.cpp
===================================================================
--- /GTP/trunk/App/Games/Jungle_Rumble/src/UserPlayer.cpp	(revision 1378)
+++ /GTP/trunk/App/Games/Jungle_Rumble/src/UserPlayer.cpp	(revision 1403)
@@ -66,2 +66,14 @@
 	}
 }*/
+
+extern bool GLOBAL_player_freezeQ;
+
+void UserPlayer::update(float dt)
+{
+	if(GLOBAL_player_freezeQ) { 
+		this->setBehaveAs(Node::KINEMATIC);
+		return; 
+	}
+
+	Player::update(dt);
+}
Index: /GTP/trunk/App/Games/Jungle_Rumble/bin/config.xml
===================================================================
--- /GTP/trunk/App/Games/Jungle_Rumble/bin/config.xml	(revision 1398)
+++ /GTP/trunk/App/Games/Jungle_Rumble/bin/config.xml	(revision 1403)
@@ -3,5 +3,5 @@
 	<width>1024</width>
 	<height>768</height>
-	<fullscreen>1</fullscreen> <!-- 1 = TRUE, 0 = FALSE -->
+	<fullscreen>0</fullscreen> <!-- 1 = TRUE, 0 = FALSE -->
 	<cubemapsize>512</cubemapsize> <!-- 512, 1024, 2048, ... - current ATI cards have problems with size above 512 -->
 	<physxdebug>0</physxdebug>   <!-- 1 = TRUE, 0 = FALSE -->