Index: GTP/trunk/App/Games/Jungle_Rumble/src/GameManager.cpp
===================================================================
--- GTP/trunk/App/Games/Jungle_Rumble/src/GameManager.cpp	(revision 1407)
+++ GTP/trunk/App/Games/Jungle_Rumble/src/GameManager.cpp	(revision 1410)
@@ -72,9 +72,11 @@
 	std::wstring s;
 	//s += L"HELP:\n drive: w-a-s-d\n shoot: left mouse\n F2: show FPS\n F3: PhysX Debugger\n F4: Music On/Off";
-	s += L"HELP:\n drive: w-a-s-d\n shoot: left mouse";
+	s += L"JUNGLE RUMBLE HELP\n drive: w-a-s-d\n shoot: left mouse";
 	s += L"\n Pause: Pause Game"; 
 	s += L"\n";
 
-	s += L"\n 1 Big Guns\n 2 Bombs - explode late, but do cause lots of damage!\n 3 Alien weapon - just shoot!\n 4 Flamethrower - Toast your opponents\n 5 Icethrower - Slows down opponents (then toast them ;-) )";
+	s += L"\n 1: Big Gun\n 2: Bombs - explode late, but cause lots of damage!";
+	s += L"\n 3: Alien weapon\n 4: Flamethrower (Toast your opponents ;-))";
+	s += L"\n 5: Ice Gun - Slows down opponents";
 	s += L"\n";
 
Index: GTP/trunk/App/Games/Jungle_Rumble/bin/readme.txt
===================================================================
--- GTP/trunk/App/Games/Jungle_Rumble/bin/readme.txt	(revision 1391)
+++ GTP/trunk/App/Games/Jungle_Rumble/bin/readme.txt	(revision 1410)
@@ -21,14 +21,19 @@
 reflected/refracted objects are near the reflector/refractor. 
 
-Raytrace Effects are used for several (see "Raining..." level) - in some levels ("Surprise!") moving - objects. 
+Raytrace Effects are used on several objects, which can also be moving (see "Raining..." and 
+"Surprise!" level, respectively).
+
 Depth Imposter are used for explosions, lava-fire (see "Volcano" level) and for the 
-partcicle effects of the Flame- and Icethrower (press "4" and "5" to activate these), 
-combined with a heat blur.
+partcicle effects of the Flamethrower and Ice-Gun (press "4" and "5" to activate them).
 
 Jungle Rumble was started in the early phase of the GameTools Project, 
-and therefore uses its own Direct3D 9 engine (and not OGRE or Shark3D).
+and therefore uses its own Direct3D 9 engine.
 
-The game starts in 800x600 window mode, using 512x512 textures for the Raytrace Effects cubemap. 
-You can easily change these settings in the "config.xml" file, residing in the same directory as this file.
+
+Configuration and Use
+=====================
+
+The game starts in 1024x768 fullscreen mode, using 512x512 textures for the Raytrace Effects cubemap. 
+You can easily change these settings in the "config.xml" file, residing in the same directory as the executable.
 
 During the game, you can toggle Depth Imposters with conventional decal particle rendering with F9; 
@@ -44,5 +49,5 @@
 based on leading edge computer graphics research. 
 It makes these libraries available to European developers (or companies developing software within the EU)
-for free (including support) !
+for free, including support !
 All the companies have to do is joing the GTP Special Interest Group.
 To learn more about the GameTools Project and how to join, go to our webpage at http://www.gametools.org, 
@@ -54,19 +59,19 @@
 (Press F1 during the game, to get the same information)
 
-w-a-s-d		Navigate your vehicle
+w-a-s-d     Navigate your vehicle
 left mouse	shoot
-1		Standard weapon
-2		Bombs - they explode later but can hurt really much
-3		Alien weapon - just shoot!
-4		Firethrower - Burn your opponent
-5		Icethrower - Slow down your opponent to toast it with the firethrower
+1   Big Gun 
+2   Bombs - explode late, but pack a lot of punch
+3   Alien Weapon - just shoot!
+4   Flamehrower - A warm welcome for those zebras
+5   Ice-Gun - Slow down your opponents to toast them with the flamethrower
 
-F1		Display help (toggle)
-F2		FPS on/off
-F3		Enable PhysX Debugger (Note: you only can switch it on/off wenn you turn it on in the config.xml file)
-F4		Music on/off
-F9		Depthimposters on/off
-F10		Raytracer on/off
-F11		Enable/Disable fire of the opponents (For looking at the GameTools effects undisturbed - no cheating! ;-)
+F1  Display help (toggle)
+F2  FPS on/off
+F3  Enable PhysX Debugger (Note: you only can switch it on/off wenn you turn it on in the config.xml file)
+F4  Music on/off
+F9  Depthimposters on/off
+F10 Raytracer on/off
+F11 Enable/Disable fire of the opponents (For looking at the GameTools effects undisturbed - no cheating! ;-)
 
 